diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
index 70d73ae05..35f13b428 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
@@ -6,20 +6,20 @@ import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
 
 public class BlockModelDispatcher
-    extends Dispatcher<Block, BlockModel>
+    extends Dispatcher<Block<?>, BlockModel<?>>
 {
     private static BlockModelDispatcher instance = new BlockModelDispatcher();
     public static BlockModelDispatcher getInstance()
     {
         return instance;
     }
-    public static BlockModelEmpty modelEmpty = new BlockModelEmpty(null);
-    public void addDispatch(BlockModel dispatchable)
+    public static BlockModelEmpty<?> modelEmpty = new BlockModelEmpty<>(null);
+    public void addDispatch(BlockModel<?> model)
     {
-        addDispatch(dispatchable.block, dispatchable);
+        addDispatch(model.block, model);
     }
     @Override
-    public void addDispatch(Block key, BlockModel value)
+    public void addDispatch(Block<?> key, BlockModel<?> value)
     {
         if (dispatches.containsValue(key)){
             throw new IllegalArgumentException("Block '" + key.toString() + "' already assigned a model!");
@@ -27,7 +27,7 @@ public class BlockModelDispatcher
         dispatches.put(key, value);
     }
     @Override
-    protected BlockModel getDefault()
+    protected BlockModel<?> getDefault()
     {
         return modelEmpty;
     }
@@ -293,8 +293,8 @@ public class BlockModelDispatcher
 
         addDispatch(new BlockModelWireRedstone<>(Blocks.WIRE_REDSTONE));
 
-        addDispatch(new BlockModelTorchRedstone(Blocks.TORCH_REDSTONE_IDLE).withTextures("minecraft:block/torch_redstone_idle"));
-        addDispatch(new BlockModelTorchRedstone(Blocks.TORCH_REDSTONE_ACTIVE).withTextures("minecraft:block/torch_redstone_active"));
+        addDispatch(new BlockModelTorchRedstone<>(Blocks.TORCH_REDSTONE_IDLE).withTextures("minecraft:block/torch_redstone_idle"));
+        addDispatch(new BlockModelTorchRedstone<>(Blocks.TORCH_REDSTONE_ACTIVE).withTextures("minecraft:block/torch_redstone_active"));
 
         final float width = 0.1875F;
         final float height = 0.125F;
@@ -333,7 +333,7 @@ public class BlockModelDispatcher
             .withCustomItemBounds(0,0,0,1,1,1));
 
         addDispatch(new BlockModelPistonHead(Blocks.PISTON_HEAD, TextureRegistry.getTexture("minecraft:block/piston/side")).withTextures("minecraft:block/piston/face"));
-        addDispatch(new BlockModelEmpty(Blocks.PISTON_MOVING));
+        addDispatch(new BlockModelEmpty<>(Blocks.PISTON_MOVING));
         addDispatch(new BlockModelPistonHead(Blocks.PISTON_HEAD_STEEL, TextureRegistry.getTexture("minecraft:block/piston_steel/side"), 6/16d).withTextures("minecraft:block/piston_steel/face"));
 
         addDispatch(new BlockModelStandard<>(Blocks.NOTEBLOCK).withTextures("minecraft:block/noteblock"));
@@ -345,7 +345,7 @@ public class BlockModelDispatcher
         addDispatch(new BlockModelSpikes<>(Blocks.SPIKES).withTextures("minecraft:block/spikes/top", "minecraft:block/spikes/bottom", "minecraft:block/spikes/side"));
 
         addDispatch(new BlockModelVeryRotatable<>(Blocks.DISPENSER_COBBLE_STONE).withTextures("minecraft:block/dispenser/top", "minecraft:block/dispenser/bottom", "minecraft:block/dispenser/side", "minecraft:block/dispenser/side", "minecraft:block/dispenser/front", "minecraft:block/dispenser/side"));
-        addDispatch(new BlockModelActivator(Blocks.ACTIVATOR_COBBLE_NETHERRACK).withTextures("minecraft:block/activator/top", "minecraft:block/activator/bottom", "minecraft:block/activator/side", "minecraft:block/activator/side", "minecraft:block/activator/front", "minecraft:block/activator/side"));
+        addDispatch(new BlockModelActivator<>(Blocks.ACTIVATOR_COBBLE_NETHERRACK).withTextures("minecraft:block/activator/top", "minecraft:block/activator/bottom", "minecraft:block/activator/side", "minecraft:block/activator/side", "minecraft:block/activator/front", "minecraft:block/activator/side"));
 
         addDispatch(new BlockModelTrapDoor<>(Blocks.TRAPDOOR_PLANKS_OAK).withTextures("minecraft:block/trapdoor/planks/top", "minecraft:block/trapdoor/planks/side"));
         addDispatch(new BlockModelTrapDoor<>(Blocks.TRAPDOOR_IRON).withTextures("minecraft:block/trapdoor/iron/top", "minecraft:block/trapdoor/iron/side"));
@@ -400,9 +400,9 @@ public class BlockModelDispatcher
 
         addDispatch(new BlockModelFarmland<>(Blocks.FARMLAND_DIRT).withTextures("minecraft:block/farmland/dry"));
 
-        addDispatch(new BlockModelEmpty(Blocks.SIGN_POST_PLANKS_OAK).withTextures("minecraft:block/planks/oak"));
-        addDispatch(new BlockModelEmpty(Blocks.SIGN_WALL_PLANKS_OAK).withTextures("minecraft:block/planks/oak"));
-        addDispatch(new BlockModelEmpty(Blocks.FLAG).withTextures("minecraft:block/planks/oak"));
+        addDispatch(new BlockModelEmpty<>(Blocks.SIGN_POST_PLANKS_OAK).withTextures("minecraft:block/planks/oak"));
+        addDispatch(new BlockModelEmpty<>(Blocks.SIGN_WALL_PLANKS_OAK).withTextures("minecraft:block/planks/oak"));
+        addDispatch(new BlockModelEmpty<>(Blocks.FLAG).withTextures("minecraft:block/planks/oak"));
 
         addDispatch(new BlockModelLayer<>(Blocks.LAYER_SNOW).withTextures("minecraft:block/block_snow"));
         addDispatch(new BlockModelLayer<>(Blocks.LAYER_LEAVES_OAK).withTextures("minecraft:block/leaves/oak_fancy"));
@@ -427,7 +427,7 @@ public class BlockModelDispatcher
         addDispatch(new BlockModelHorizontalRotation<>(Blocks.PUMPKIN).withTextures("minecraft:block/pumpkin/top", "minecraft:block/pumpkin/bottom", "minecraft:block/pumpkin/side"));
         addDispatch(new BlockModelHorizontalRotation<>(Blocks.PUMPKIN_CARVED_IDLE).withTextures("minecraft:block/pumpkin_carved/top", "minecraft:block/pumpkin_carved/bottom", "minecraft:block/pumpkin_carved/front", "minecraft:block/pumpkin_carved/side", "minecraft:block/pumpkin_carved/side", "minecraft:block/pumpkin_carved/side"));
         addDispatch(new BlockModelHorizontalRotation<>(Blocks.PUMPKIN_CARVED_ACTIVE).withTextures("minecraft:block/pumpkin_carved_lit/top", "minecraft:block/pumpkin_carved_lit/bottom", "minecraft:block/pumpkin_carved_lit/front", "minecraft:block/pumpkin_carved_lit/side", "minecraft:block/pumpkin_carved_lit/side", "minecraft:block/pumpkin_carved_lit/side"));
-        addDispatch(new BlockModelPumpkinRedstone(Blocks.PUMPKIN_REDSTONE).withTextures("minecraft:block/pumpkin_redstone/top", "minecraft:block/pumpkin_redstone/bottom", "minecraft:block/pumpkin_redstone/front", "minecraft:block/pumpkin_redstone/side", "minecraft:block/pumpkin_redstone/side", "minecraft:block/pumpkin_redstone/side"));
+        addDispatch(new BlockModelPumpkinRedstone<>(Blocks.PUMPKIN_REDSTONE).withTextures("minecraft:block/pumpkin_redstone/top", "minecraft:block/pumpkin_redstone/bottom", "minecraft:block/pumpkin_redstone/front", "minecraft:block/pumpkin_redstone/side", "minecraft:block/pumpkin_redstone/side", "minecraft:block/pumpkin_redstone/side"));
 
 
         addDispatch(new BlockModelStandard<>(Blocks.COBBLE_NETHERRACK).withTextures("minecraft:block/cobbled_netherrack"));
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDoor.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDoor.java
index 714072c78..e56bd181f 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDoor.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDoor.java
@@ -5,12 +5,12 @@ import net.minecraft.client.render.RenderBlocks;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.BlockDoor;
+import net.minecraft.core.block.BlockLogicDoor;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
 
-public class BlockModelDoor<T extends BlockDoor> extends BlockModelStandard<T> {
-    public BlockModelDoor(Block block) {
+public class BlockModelDoor<T extends BlockLogicDoor> extends BlockModelStandard<T> {
+    public BlockModelDoor(Block<T> block) {
         super(block);
     }
     
@@ -44,8 +44,8 @@ public class BlockModelDoor<T extends BlockDoor> extends BlockModelStandard<T> {
 			sideEastWest = 0.6f;
 		}
 		
-		boolean aboveIsDoor = renderBlocks.blockAccess.getBlock(x, y + 1, z) instanceof BlockDoor;
-		boolean belowIsDoor = renderBlocks.blockAccess.getBlock(x, y - 1, z) instanceof BlockDoor;
+		boolean aboveIsDoor = Block.hasLogicClass(renderBlocks.blockAccess.getBlock(x, y + 1, z), BlockLogicDoor.class);
+		boolean belowIsDoor = Block.hasLogicClass(renderBlocks.blockAccess.getBlock(x, y - 1, z), BlockLogicDoor.class);
 
 		int meta = renderBlocks.blockAccess.getBlockMetadata(x, y, z);
 		
@@ -120,7 +120,7 @@ public class BlockModelDoor<T extends BlockDoor> extends BlockModelStandard<T> {
     }
     protected boolean shouldFlipTexture(Side side, int meta){
         if(side == Side.TOP || side == Side.BOTTOM) return false;
-        int state = block.getRotation(meta);
+        int state = block.getLogic().getRotation(meta);
         int l = state / 2 + (side.getId() & 1 ^ state);
         if((state == 0 || state == 2) ^ (side.getId() <= 3))
         {
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDoorGlass.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDoorGlass.java
index a2c5ba964..cecdafc59 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDoorGlass.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDoorGlass.java
@@ -1,11 +1,11 @@
 package net.minecraft.client.render.block.model;
 
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.BlockDoor;
+import net.minecraft.core.block.BlockLogicDoor;
 import net.minecraft.core.util.helper.Side;
 
-public class BlockModelDoorGlass<T extends BlockDoor> extends BlockModelDoor<T> {
-    public BlockModelDoorGlass(Block block) {
+public class BlockModelDoorGlass<T extends BlockLogicDoor> extends BlockModelDoor<T> {
+    public BlockModelDoorGlass(Block<T> block) {
         super(block);
     }
     @Override
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDoorPainted.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDoorPainted.java
index 61dd40e60..8eca872ad 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDoorPainted.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDoorPainted.java
@@ -3,12 +3,12 @@ package net.minecraft.client.render.block.model;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.BlockDoor;
+import net.minecraft.core.block.BlockLogicDoor;
 import net.minecraft.core.util.helper.Axis;
 import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.util.helper.Side;
 
-public class BlockModelDoorPainted<T extends BlockDoor> extends BlockModelDoor<T> {
+public class BlockModelDoorPainted<T extends BlockLogicDoor> extends BlockModelDoor<T> {
     public static final IconCoordinate[] doorBottomTextures = new IconCoordinate[DyeColor.COLOR_AMOUNT];
     public static final IconCoordinate[] doorTopTextures = new IconCoordinate[DyeColor.COLOR_AMOUNT];
     public static final IconCoordinate[] frameTopTextures = new IconCoordinate[DyeColor.COLOR_AMOUNT];
@@ -21,7 +21,7 @@ public class BlockModelDoorPainted<T extends BlockDoor> extends BlockModelDoor<T
         }
     }
     private final boolean isTop;
-    public BlockModelDoorPainted(Block block, boolean isTop) {
+    public BlockModelDoorPainted(Block<T> block, boolean isTop) {
         super(block);
         this.isTop = isTop;
     }
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelEmpty.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelEmpty.java
index 4364c2b58..8c01dacce 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelEmpty.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelEmpty.java
@@ -3,11 +3,12 @@ package net.minecraft.client.render.block.model;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.util.helper.Side;
 import org.jetbrains.annotations.Nullable;
 
-public class BlockModelEmpty extends BlockModelStandard<Block> {
-    public BlockModelEmpty(Block block) {
+public class BlockModelEmpty<T extends BlockLogic> extends BlockModelStandard<T> {
+    public BlockModelEmpty(Block<T> block) {
         super(block);
     }
 
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFarmland.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFarmland.java
index d5455d4dd..a99cc6e5c 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFarmland.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFarmland.java
@@ -3,28 +3,28 @@ package net.minecraft.client.render.block.model;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.Blocks;
-import net.minecraft.core.block.BlockFarmland;
+import net.minecraft.core.block.BlockLogic;
+import net.minecraft.core.block.BlockLogicFarmland;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.WorldSource;
 
-public class BlockModelFarmland<T extends Block> extends BlockModelStandard<T> {
+public class BlockModelFarmland<T extends BlockLogic> extends BlockModelStandard<T> {
     protected IconCoordinate topWet = TextureRegistry.getTexture("minecraft:block/farmland/wet_top");
     protected IconCoordinate topWetFertilized = TextureRegistry.getTexture("minecraft:block/farmland/wet_fertilized_top");
     protected IconCoordinate topDry = TextureRegistry.getTexture("minecraft:block/farmland/dry_top");
     protected IconCoordinate topDryFertilized = TextureRegistry.getTexture("minecraft:block/farmland/dry_fertilized_top");
     protected IconCoordinate mud = TextureRegistry.getTexture("minecraft:block/farmland/wet");
 
-    public BlockModelFarmland(Block block) {
+    public BlockModelFarmland(Block<T> block) {
         super(block);
     }
 
     @Override
     public IconCoordinate getBlockTextureFromSideAndMetadata(Side side, final int data)
     {
-        boolean isWet = BlockFarmland.isWet(data);
-        boolean isFertilized = BlockFarmland.isFertilized(data);
+        boolean isWet = BlockLogicFarmland.isWet(data);
+        boolean isFertilized = BlockLogicFarmland.isFertilized(data);
 
         if (side == Side.TOP) {
             if (isWet && isFertilized) {
@@ -46,7 +46,7 @@ public class BlockModelFarmland<T extends Block> extends BlockModelStandard<T> {
 
     @Override
     public boolean shouldSideBeRendered(WorldSource blockAccess, AABB bounds, int x, int y, int z, int side) {
-        if (side >= 2 && blockAccess.getBlockId(x, y, z) == Blocks.FARMLAND_DIRT.id) return false;
+        if (side >= 2 && blockAccess.getBlockId(x, y, z) == block.id()) return false;
         return super.shouldSideBeRendered(blockAccess, bounds, x, y, z, side);
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFence.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFence.java
index 3b21d2d7c..28346c6b2 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFence.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFence.java
@@ -3,14 +3,14 @@ package net.minecraft.client.render.block.model;
 import net.minecraft.client.render.block.color.BlockColorDispatcher;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.BlockFence;
+import net.minecraft.core.block.BlockLogicFence;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
 import org.jetbrains.annotations.Nullable;
 import org.lwjgl.opengl.GL11;
 
-public class BlockModelFence<T  extends BlockFence> extends BlockModelStandard<T> {
-    public BlockModelFence(Block block) {
+public class BlockModelFence<T  extends BlockLogicFence> extends BlockModelStandard<T> {
+    public BlockModelFence(Block<T> block) {
         super(block);
     }
 
@@ -22,18 +22,19 @@ public class BlockModelFence<T  extends BlockFence> extends BlockModelStandard<T
         renderStandardBlock(tessellator, bounds, x, y, z);
         boolean flag1 = false;
         boolean flag2 = false;
-        if(block.canConnectTo(renderBlocks.blockAccess, x - 1, y, z) || block.canConnectTo(renderBlocks.blockAccess, x + 1, y, z))
+        BlockLogicFence fence = block.getLogic();
+        if(fence.canConnectTo(renderBlocks.blockAccess, x - 1, y, z) || fence.canConnectTo(renderBlocks.blockAccess, x + 1, y, z))
         {
             flag1 = true;
         }
-        if(block.canConnectTo(renderBlocks.blockAccess, x, y, z - 1) || block.canConnectTo(renderBlocks.blockAccess, x, y, z + 1))
+        if(fence.canConnectTo(renderBlocks.blockAccess, x, y, z - 1) || fence.canConnectTo(renderBlocks.blockAccess, x, y, z + 1))
         {
             flag2 = true;
         }
-        boolean flag3 = block.canConnectTo(renderBlocks.blockAccess, x - 1, y, z);
-        boolean flag4 = block.canConnectTo(renderBlocks.blockAccess, x + 1, y, z);
-        boolean flag5 = block.canConnectTo(renderBlocks.blockAccess, x, y, z - 1);
-        boolean flag6 = block.canConnectTo(renderBlocks.blockAccess, x, y, z + 1);
+        boolean flag3 = fence.canConnectTo(renderBlocks.blockAccess, x - 1, y, z);
+        boolean flag4 = fence.canConnectTo(renderBlocks.blockAccess, x + 1, y, z);
+        boolean flag5 = fence.canConnectTo(renderBlocks.blockAccess, x, y, z - 1);
+        boolean flag6 = fence.canConnectTo(renderBlocks.blockAccess, x, y, z + 1);
         if(!flag1 && !flag2)
         {
             flag1 = true;
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFenceGate.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFenceGate.java
index 617c77436..7adc7272d 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFenceGate.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFenceGate.java
@@ -3,14 +3,14 @@ package net.minecraft.client.render.block.model;
 import net.minecraft.client.render.block.color.BlockColorDispatcher;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.BlockFenceGate;
+import net.minecraft.core.block.BlockLogicFenceGate;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
 import org.jetbrains.annotations.Nullable;
 import org.lwjgl.opengl.GL11;
 
-public class BlockModelFenceGate<T extends BlockFenceGate> extends BlockModelStandard<T> {
-    public BlockModelFenceGate(Block block) {
+public class BlockModelFenceGate<T extends BlockLogicFenceGate> extends BlockModelStandard<T> {
+    public BlockModelFenceGate(Block<T> block) {
         super(block);
     }
 
@@ -19,8 +19,8 @@ public class BlockModelFenceGate<T extends BlockFenceGate> extends BlockModelSta
         AABB bounds = block.getBounds();
         boolean flag = true;
         int l = renderBlocks.blockAccess.getBlockMetadata(x, y, z);
-        boolean flag1 = BlockFenceGate.isOpen(l);
-        int i1 = BlockFenceGate.getDirection(l);
+        boolean flag1 = BlockLogicFenceGate.isOpen(l);
+        int i1 = BlockLogicFenceGate.getDirection(l);
         if(i1 == 3 || i1 == 1)
         {
             float f = 0.4375F;
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFenceGatePainted.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFenceGatePainted.java
index d9603f8fc..ab9ed48ad 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFenceGatePainted.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFenceGatePainted.java
@@ -2,11 +2,11 @@ package net.minecraft.client.render.block.model;
 
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.BlockFenceGate;
+import net.minecraft.core.block.BlockLogicFenceGate;
 import net.minecraft.core.util.helper.Side;
 
-public class BlockModelFenceGatePainted<T extends BlockFenceGate> extends BlockModelFenceGate<T> {
-    public BlockModelFenceGatePainted(Block block) {
+public class BlockModelFenceGatePainted<T extends BlockLogicFenceGate> extends BlockModelFenceGate<T> {
+    public BlockModelFenceGatePainted(Block<T> block) {
         super(block);
     }
 
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFencePainted.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFencePainted.java
index 10ef9687a..ed0480db3 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFencePainted.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFencePainted.java
@@ -2,13 +2,13 @@ package net.minecraft.client.render.block.model;
 
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.BlockFence;
+import net.minecraft.core.block.BlockLogicFence;
 import net.minecraft.core.util.helper.Side;
 
-public class BlockModelFencePainted<T extends BlockFence> extends BlockModelFence<T> {
+public class BlockModelFencePainted<T extends BlockLogicFence> extends BlockModelFence<T> {
 
 
-    public BlockModelFencePainted(Block block) {
+    public BlockModelFencePainted(Block<T> block) {
         super(block);
     }
 
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFenceThin.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFenceThin.java
index b3111e2ed..416c521bc 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFenceThin.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFenceThin.java
@@ -6,19 +6,19 @@ import net.minecraft.client.render.block.color.BlockColorDispatcher;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.BlockFenceThin;
+import net.minecraft.core.block.BlockLogicFenceThin;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.phys.AABB;
 import org.jetbrains.annotations.Nullable;
 import org.lwjgl.opengl.GL11;
 
-public class BlockModelFenceThin<T extends BlockFenceThin> extends BlockModelStandard<T> {
+public class BlockModelFenceThin<T extends BlockLogicFenceThin> extends BlockModelStandard<T> {
     private final IconCoordinate texIndex;
     private final IconCoordinate bottomTexIndex;
     private final IconCoordinate topTexIndex;
     private final IconCoordinate columnTexIndex;
 
-    public BlockModelFenceThin(Block block, IconCoordinate texIndex, IconCoordinate bottomTexIndex, IconCoordinate topTexIndex, IconCoordinate columnTexIndex){
+    public BlockModelFenceThin(Block<T> block, IconCoordinate texIndex, IconCoordinate bottomTexIndex, IconCoordinate topTexIndex, IconCoordinate columnTexIndex){
         super(block);
         this.texIndex = texIndex;
         this.bottomTexIndex = bottomTexIndex;
@@ -45,11 +45,11 @@ public class BlockModelFenceThin<T extends BlockFenceThin> extends BlockModelSta
 			cNorthSouth = 0.8f;
 			cEastWest = 0.6f;
 		}
-
-        boolean connectNorth = block.canConnectTo(renderBlocks.blockAccess, x + Direction.NORTH.getOffsetX(), y + Direction.NORTH.getOffsetY(), z + Direction.NORTH.getOffsetZ());
-        boolean connectSouth = block.canConnectTo(renderBlocks.blockAccess, x + Direction.SOUTH.getOffsetX(), y + Direction.SOUTH.getOffsetY(), z + Direction.SOUTH.getOffsetZ());
-        boolean connectEast = block.canConnectTo(renderBlocks.blockAccess, x + Direction.EAST.getOffsetX(), y + Direction.EAST.getOffsetY(), z + Direction.EAST.getOffsetZ());
-        boolean connectWest = block.canConnectTo(renderBlocks.blockAccess, x + Direction.WEST.getOffsetX(), y + Direction.WEST.getOffsetY(), z + Direction.WEST.getOffsetZ());
+        BlockLogicFenceThin thin = block.getLogic();
+        boolean connectNorth = thin.canConnectTo(renderBlocks.blockAccess, x + Direction.NORTH.getOffsetX(), y + Direction.NORTH.getOffsetY(), z + Direction.NORTH.getOffsetZ());
+        boolean connectSouth = thin.canConnectTo(renderBlocks.blockAccess, x + Direction.SOUTH.getOffsetX(), y + Direction.SOUTH.getOffsetY(), z + Direction.SOUTH.getOffsetZ());
+        boolean connectEast = thin.canConnectTo(renderBlocks.blockAccess, x + Direction.EAST.getOffsetX(), y + Direction.EAST.getOffsetY(), z + Direction.EAST.getOffsetZ());
+        boolean connectWest = thin.canConnectTo(renderBlocks.blockAccess, x + Direction.WEST.getOffsetX(), y + Direction.WEST.getOffsetY(), z + Direction.WEST.getOffsetZ());
 
         boolean lineNorthSouth = connectNorth && connectSouth;
         boolean lineEastWest = connectEast && connectWest;
@@ -85,19 +85,19 @@ public class BlockModelFenceThin<T extends BlockFenceThin> extends BlockModelSta
         double fenceBottommostMaxU = fenceBottommostTex.getSubIconU(onePix * 16);
         double fenceBottommostMaxV = fenceBottommostTex.getSubIconV(onePix * 16);
 
-        Block blockAbove = renderBlocks.blockAccess.getBlock(x, y + 1, z);
-        boolean connectUpNorth = blockAbove == block && block.canConnectTo(renderBlocks.blockAccess, x + Direction.NORTH.getOffsetX(), y + Direction.NORTH.getOffsetY() + 1, z + Direction.NORTH.getOffsetZ());
-        boolean connectUpSouth = blockAbove == block && block.canConnectTo(renderBlocks.blockAccess, x + Direction.SOUTH.getOffsetX(), y + Direction.SOUTH.getOffsetY() + 1, z + Direction.SOUTH.getOffsetZ());
-        boolean connectUpEast = blockAbove == block && block.canConnectTo(renderBlocks.blockAccess, x + Direction.EAST.getOffsetX(), y + Direction.EAST.getOffsetY() + 1, z + Direction.EAST.getOffsetZ());
-        boolean connectUpWest = blockAbove == block && block.canConnectTo(renderBlocks.blockAccess, x + Direction.WEST.getOffsetX(), y + Direction.WEST.getOffsetY() + 1, z + Direction.WEST.getOffsetZ());
+        Block<?> blockAbove = renderBlocks.blockAccess.getBlock(x, y + 1, z);
+        boolean connectUpNorth = blockAbove == block && thin.canConnectTo(renderBlocks.blockAccess, x + Direction.NORTH.getOffsetX(), y + Direction.NORTH.getOffsetY() + 1, z + Direction.NORTH.getOffsetZ());
+        boolean connectUpSouth = blockAbove == block && thin.canConnectTo(renderBlocks.blockAccess, x + Direction.SOUTH.getOffsetX(), y + Direction.SOUTH.getOffsetY() + 1, z + Direction.SOUTH.getOffsetZ());
+        boolean connectUpEast = blockAbove == block && thin.canConnectTo(renderBlocks.blockAccess, x + Direction.EAST.getOffsetX(), y + Direction.EAST.getOffsetY() + 1, z + Direction.EAST.getOffsetZ());
+        boolean connectUpWest = blockAbove == block && thin.canConnectTo(renderBlocks.blockAccess, x + Direction.WEST.getOffsetX(), y + Direction.WEST.getOffsetY() + 1, z + Direction.WEST.getOffsetZ());
 
-        Block blockBelow = renderBlocks.blockAccess.getBlock(x, y - 1, z);
-        boolean connectDownNorth = blockBelow == block && block.canConnectTo(renderBlocks.blockAccess, x + Direction.NORTH.getOffsetX(), y + Direction.NORTH.getOffsetY() - 1, z + Direction.NORTH.getOffsetZ());
-        boolean connectDownSouth = blockBelow == block && block.canConnectTo(renderBlocks.blockAccess, x + Direction.SOUTH.getOffsetX(), y + Direction.SOUTH.getOffsetY() - 1, z + Direction.SOUTH.getOffsetZ());
-        boolean connectDownEast = blockBelow == block && block.canConnectTo(renderBlocks.blockAccess, x + Direction.EAST.getOffsetX(), y + Direction.EAST.getOffsetY() - 1, z + Direction.EAST.getOffsetZ());
-        boolean connectDownWest = blockBelow == block && block.canConnectTo(renderBlocks.blockAccess, x + Direction.WEST.getOffsetX(), y + Direction.WEST.getOffsetY() - 1, z + Direction.WEST.getOffsetZ());
+        Block<?> blockBelow = renderBlocks.blockAccess.getBlock(x, y - 1, z);
+        boolean connectDownNorth = blockBelow == block && thin.canConnectTo(renderBlocks.blockAccess, x + Direction.NORTH.getOffsetX(), y + Direction.NORTH.getOffsetY() - 1, z + Direction.NORTH.getOffsetZ());
+        boolean connectDownSouth = blockBelow == block && thin.canConnectTo(renderBlocks.blockAccess, x + Direction.SOUTH.getOffsetX(), y + Direction.SOUTH.getOffsetY() - 1, z + Direction.SOUTH.getOffsetZ());
+        boolean connectDownEast = blockBelow == block && thin.canConnectTo(renderBlocks.blockAccess, x + Direction.EAST.getOffsetX(), y + Direction.EAST.getOffsetY() - 1, z + Direction.EAST.getOffsetZ());
+        boolean connectDownWest = blockBelow == block && thin.canConnectTo(renderBlocks.blockAccess, x + Direction.WEST.getOffsetX(), y + Direction.WEST.getOffsetY() - 1, z + Direction.WEST.getOffsetZ());
 
-        if (block.shouldDrawColumn(renderBlocks.blockAccess, x, y, z))
+        if (thin.shouldDrawColumn(renderBlocks.blockAccess, x, y, z))
         {
             double sidesMinU = columnTexIndex.getIconUMin();
             double sidesMinV = columnTexIndex.getIconVMin();
